<script lang="ts">
import Vue, { PropType } from 'vue';
import { IsMobileMixin } from '../../mixins';

interface metric {
  number: string;
  text: string;
}

interface quoteCard {
  headline?: string;
  logo?: string;
  quote: string;
  metrics: metric[];
  author?: {
    headshot?: string;
    name: string;
    title: string;
    company: string;
  };
  cta: {
    text?: string;
    url: string;
    dataGaName?: string;
    dataGaLocation?: string;
  };
}

export default Vue.extend({
  name: 'QuoteCarousel',
  mixins: [IsMobileMixin],
  props: {
    header: {
      type: String,
      required: false,
      default: '',
    },
    cards: {
      type: Array as PropType<quoteCard[]>,
      required: true,
    },
    darkMode: {
      type: Boolean,
      required: false,
      default: false,
    },
    containerVariant: {
      type: String,
      required: false,
      default: '',
    },
    purpleBackground: {
      type: Boolean,
      required: false,
      default: false,
    },
    height: {
      type: Number,
      required: false,
      default: 760,
    },
  },
  data() {
    return { selectedCardIndex: 0, animation: 'fade' };
  },
  computed: {
    selectedCard() {
      return this.cards[this.selectedCardIndex];
    },
  },
  methods: {
    nextCard(): void {
      if (this.selectedCardIndex + 1 === this.cards.length) {
        this.selectedCardIndex = 0;
      } else {
        this.selectedCardIndex++;
      }
      this.animation = 'fade';
    },
    prevCard(): void {
      if (this.selectedCardIndex === 0) {
        this.selectedCardIndex = this.cards.length - 1;
      } else {
        this.selectedCardIndex--;
      }
      this.animation = 'fade-left';
    },
  },
});
</script>
<template>
  <section
    class="section"
    aria-roledescription="carousel"
    aria-label="Customer Quote Carousel"
    :data-darkmode="darkMode"
  >
    <SlpContainer
      class="quote-carousel-wrapper"
      :class="{
        'nav-purple-background': purpleBackground,
        'dark-mode': darkMode,
      }"
      :style="`--height: ${height}px;`"
      :variant="containerVariant"
    >
      <div class="header">
        <SlpTypography variant="heading2-bold">
          <div v-html="header"></div
        ></SlpTypography>
      </div>
      <div class="controls">
        <div v-if="cards.length > 1" class="arrow-btns">
          <SlpButton
            class="arrow-btns__btn"
            variant="icon"
            aria-label="Previous case study"
            @click.native="prevCard()"
            ><SlpIcon
              variant="product"
              name="chevron-lg-left"
              slp-color="color-surface-500"
          /></SlpButton>
          <SlpButton
            class="arrow-btns__btn"
            variant="icon"
            aria-label="Next case study"
            @click.native="nextCard()"
            ><SlpIcon
              variant="product"
              name="chevron-lg-right"
              slp-color="color-surface-500"
          /></SlpButton>
        </div>
      </div>
      <transition :name="animation" mode="out-in">
        <div :key="selectedCard.quote" class="quote-carousel">
          <div class="logo">
            <img :src="selectedCard.logo" alt="" aria-label="" />
          </div>
          <div class="content">
            <div class="quote-container">
              <SlpTypography
                v-if="selectedCard.headline"
                class="headline"
                variant="heading5-bold"
              >
                {{ selectedCard.headline }}</SlpTypography
              >
              <SlpTypography class="quote"
                >"{{ selectedCard.quote }}"</SlpTypography
              >
              <div v-if="selectedCard.metrics && isMobile" class="metrics">
                <div
                  v-for="metric in selectedCard.metrics"
                  :key="metric.text"
                  class="metric"
                >
                  <SlpTypography variant="heading5-bold" class="number">{{
                    metric.number
                  }}</SlpTypography>
                  <SlpTypography variant="body3" class="text">{{
                    metric.text
                  }}</SlpTypography>
                </div>
              </div>
              <div v-if="selectedCard.author" class="author">
                <img
                  v-if="selectedCard.author.headshot"
                  class="headshot"
                  :src="selectedCard.author.headshot"
                />
                <div class="information">
                  <SlpTypography variant="body2-bold" class="name">{{
                    selectedCard.author.name
                  }}</SlpTypography>
                  <SlpTypography variant="body2" class="title"
                    >{{ selectedCard.author.title
                    }}{{
                      selectedCard.author.company &&
                      `, ${selectedCard.author.company}`
                    }}</SlpTypography
                  >
                </div>
              </div>
              <div class="cta">
                <SlpButton
                  class="button"
                  variant="tertiary"
                  :href="selectedCard.cta.url"
                  :data-ga-name="selectedCard.cta.dataGaName"
                  :data-ga-location="selectedCard.cta.dataGaLocation || 'body'"
                  >{{ selectedCard.cta.text || 'View case study' }}
                  <SlpIcon variant="product" name="chevron-lg-right"
                /></SlpButton>
              </div>
            </div>
            <div v-if="selectedCard.metrics && !isMobile" class="metrics">
              <div
                v-for="metric in selectedCard.metrics"
                :key="metric.text"
                class="metric"
              >
                <SlpTypography variant="heading5-bold" class="number">{{
                  metric.number
                }}</SlpTypography>
                <SlpTypography variant="body3" class="text">{{
                  metric.text
                }}</SlpTypography>
              </div>
            </div>
          </div>
        </div>
      </transition>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.quote-carousel-wrapper {
  display: flex;
  flex-direction: column;
  position: relative;
  gap: 24px;

  @media (min-width: $breakpoint-md) {
    padding-top: 60px;
  }

  @media (max-width: $breakpoint-lg) {
    padding-top: 32px;
    padding-bottom: 32px;
  }
  @media (min-width: $breakpoint-lg) {
    gap: 32px;
    min-height: var(--height);
  }
  &.nav-purple-background::after {
    content: '';
    position: absolute;
    width: 200vw;
    height: 100%;
    top: 0;
    left: -50vw;
    z-index: -1;
    background: $color-surface-800;
  }
  &.dark-mode::after {
    content: '';
    position: absolute;
    width: 200vw;
    height: 100%;
    top: 0;
    left: -50vw;
    z-index: -1;
    background: $color-surface-700;
  }
  .controls {
    .arrow-btns {
      display: flex;
      gap: 16px;
      align-items: flex-end;
      margin-left: auto;
      justify-content: flex-end;
      &__btn {
        justify-content: center;
        border-radius: 120px;
        border: 1px solid $color-surface-900;
        padding: 8px;
        height: 40px;
        width: 40px;

        :deep(.slp-icon) {
          transform: none !important;
        }

        &:hover {
          background-color: $color-surface-950;
          color: black;
        }
      }
    }
  }
  .quote-carousel {
    display: flex;
    flex-direction: column;
    gap: 16px;
    .logo {
      img {
        max-width: 140px;
        max-height: 45px;
      }
    }
    .content {
      display: flex;
      gap: 64px;
      flex-direction: column;
      @media (min-width: $breakpoint-lg) {
        flex-direction: row;
      }
      .quote-container {
        display: flex;
        flex-direction: column;
        gap: 24px;
        .quote {
          color: $color-text-300;
          font-style: italic;
        }
        .author {
          display: flex;
          flex-direction: row;
          gap: 16px;
          align-items: center;
          img {
            border-radius: 4px 4px 22px 4px;
            width: 70px;
            height: 70px;
            object-fit: cover;
          }
          .information {
            display: flex;
            flex-direction: column;
            gap: 4px;
            justify-content: center;
          }
        }
      }
      .metrics {
        display: flex;
        flex-direction: row;
        @media (min-width: $breakpoint-lg) {
          flex-direction: column;
          max-width: 25%;
          min-width: 25%;
        }
        .metric {
          display: flex;
          padding: 24px 0px;
          flex-direction: column;
          justify-content: center;
          align-items: flex-start;
          align-self: stretch;
          &:first-child {
            @media (min-width: $breakpoint-lg) {
              border-top: 0.5px solid $color-surface-400;
            }
            @media (max-width: $breakpoint-lg) {
              padding-left: 0;
              & + .metric {
                border-left: 0.5px solid $color-surface-400;
              }
            }
          }
          border-bottom: 0.5px solid $color-surface-400;
          @media (max-width: $breakpoint-lg) {
            justify-content: center;
            border: none;
            width: 50%;
            padding: 16px;
          }
        }
      }
    }
  }
}

.dark-mode {
  .header {
    color: $color-text-50;
  }
  .headline {
    color: $color-text-50;
  }
  .quote {
    color: $color-text-100 !important;
  }
  .author {
    .name {
      color: $color-text-50;
    }
    .title {
      color: $color-text-50;
    }
  }
  .arrow-btns {
    &__btn {
      color: white;
    }
  }
  .cta {
    .button {
      color: $color-text-50;
    }
  }
}
</style>
